﻿# -*- coding: utf-8 -*-
"""
neuralnet.pyプログラム
単純な階層型ニューラルネットの計算（学習なし）
使い方　c:\>python neuralnet.py
"""
# モジュールのインポート

# グローバル変数
INPUTNO = 2       #入力数
HIDDENNO = 2      #中間層のセル数

# 下請け関数の定義
# forward()関数
def forward(wh,wo,hi,e):
    """順方向の計算"""
    #hiの計算
    for i in range(HIDDENNO):
        u = 0.0
        for j in range(INPUTNO):
            u += e[j] * wh[i][j]
        u -= wh[i][INPUTNO] #しきい値の処理
        hi[i] = f(u)
    #出力oの計算
    o=0.0
    for i in range(HIDDENNO):
        o += hi[i] * wo[i]
    o -= wo[HIDDENNO] #しきい値の処理
    return f(o)
# forward()関数の終わり

# f()関数
def f(u):
    """伝達関数(ステップ関数)"""
    #ステップ関数の計算
    if u >= 0:
        return 1.0
    else:
        return 0.0
 
# f()関数の終わり

# メイン実行部
wh = [[-2,3,-1],[-2,1,0.5]]             #中間層の重み
wo = [-60,94,-1]                        #出力層の重み
e = [[0,0],[0,1],[1,0],[1,1]]           #データセット
hi = [0 for i in range(HIDDENNO + 1)]   #中間層の出力

#計算の本体
for i in e:
    print(i,"->",forward(wh,wo,hi,i))
   
# neuralnet.pyの終わり
