﻿# -*- coding: utf-8 -*-
"""
pooling.pyプログラム
プーリングの処理  
2次元データを読み取り、プーリングを施します
使い方　c:\>python pooling.py 
"""
# モジュールのインポート
import math
import sys

# グローバル変数
INPUTSIZE = 8    #入力数

# 下請け関数の定義
# pool()関数
def pool(im,im_out):
    """プーリングの計算"""
    for i in range(0, INPUTSIZE, 2):
        for j in range(0, INPUTSIZE, 2):
            im_out[int(i / 2)][int(j / 2)] = maxpooling(im,i,j)
    return 
# pool()関数の終わり

# maxpooling()関数
def maxpooling(im,i,j):
    """最大値プーリング"""
    #値の設定
    max = im[i][j]
    #最大値の検出
    for m in range(2):
        for n in range(2):
            if max < im[i + m][j + n]:
                max = im[i + m][j + n]
    return max
# maxpooling()関数の終わり

# メイン実行部
im = [[0, 0, 0, 0, 0, 0, 0, 0], 
      [0, 3, 0, 0, 4, 0, 5, 0], 
      [0, 0, 0, 0, 0, 0, 0, 0], 
      [2, 2, 2, 2, 2, 2, 2, 2], 
      [1, 1, 1, 1, 1, 1, 1, 1], 
      [0, 0, 0, 0, 0, 0, 0, 0], 
      [3, 0, 7, 0, 1, 0, 3, 0], 
      [0, 6, 0, 5, 0, 1, 0, 3] 
     ]                                     #入力データ
im_out = [[0.0 for i in range(INPUTSIZE)] 
            for j in range(INPUTSIZE)]     #出力データ


#プーリングの計算
pool(im,im_out)

#結果の出力
for i in range(int(INPUTSIZE / 2)):
    for j in range(int(INPUTSIZE / 2)):
        print("{:.3f} ".format(im_out[i][j]),end = "")
    print()
   
# pooling.pyの終わり
